module RlogItems

  class RlogItem < ActiveRecord::Base
    default_scope :order => 'created_at DESC'
    serialize :record_changes, ActiveSupport::HashWithIndifferentAccess

    belongs_to :user
    belongs_to :record, :polymorphic => true

    validates :record, :presence => true

    def unscoped_record
      record_type.constantize.unscoped.find_by_id record_id
    end

  end
end
