require "rails"
require "rlog_items/version"
require "rlog_items/active_record_logger"
require "rlog_items/view_helpers"

module RlogItems

  class Railtie < Rails::Railtie
    initializer "rlog_items.active_record_logger" do
      ActiveRecord::Base.send :include, ActiveRecordLogger
      ActiveRecord::Base.class_eval { cattr_accessor :current_user }
      ActiveRecord::Base.class_eval { cattr_accessor :current_request }
    end

    initializer "rlog_items.view_helpers" do
      ActionView::Base.send :include, ViewHelpers
    end

  end

  class Engine < Rails::Engine
  end

end


